#include "conio.h"
#include "dos.h"
#include "stdio.h"
#define PALETA_INDEX       0x03c8
#define PALETA_DATA        0x03c9
#define INPUT_STATUS        0x03da
#define VRETRACE            0x08
typedef char byte;
typedef unsigned int word;
//
// Clase PALETA  objeto que maneja las paletas graficas				   
//
class PALETA{
	byte paleta[256*3];
	public:
		void set(byte *);
		void get();
		void baja(int);
		void sube(int);
		void carga(char *);
		void graba(char *);
		void negro();
};
//******************** baja los colores hasta negro *************************
void PALETA::negro(){
	for(int i=0;i<256*3;i++) paleta[i]-=64;set(paleta);
}
//******* Funcion set_paleta(), setea el video segun la paleta enviada ***********
void PALETA::set(byte *pal){
	outp(PALETA_INDEX,0); /* indicar a la tarjeta VGA que se va a configurar la paleta. */
	for(int i=0;i<256*3;i++){outp(PALETA_DATA,pal[i]>0?pal[i]:0);paleta[i]=pal[i];}
}
//*** Funcion get_paleta(), regresa en paleta la configuracion actual **********
void PALETA::get(){
	int i;outp(PALETA_INDEX,0);
	i=inp(PALETA_DATA);i=inp(PALETA_DATA);i=inp(PALETA_DATA);
	for(i=0;i<256*3;i++)paleta[i]=inp(PALETA_DATA);}    /* leer los datos */
//** Funcion baja_paleta(), baja gradualmente la paleta hasta desaparecer ***
void PALETA::baja(int time){
	for(int j=0;j<64;j++){
		for(int i=0;i<256*3;i++)
			paleta[i]--;
		delay(time);set(paleta);
	}
}
//** Funcion sube_paleta(), sube gradualmente la paleta hasta normal ***********
void PALETA::sube(int time){
	for(int j=0;j<64;j++){
		for(int i=0;i<256*3;i++)
			paleta[i]++;
		delay(time);set(paleta);
	}
}
//** Funcion carga_paleta(), carga desde archivo una paleta RGB 256 colores *
void PALETA::carga(char *nom){
	FILE *fp;fp=fopen(nom,"rb");if(fp==NULL){printf("no existe: %s",nom);return;}
	fread(paleta,256*3,1,fp);fclose(fp);set(paleta);}
//** Funcion graba_paleta(), graba en archivo una paleta RGB 256 colores *****
void PALETA::graba(char *nom){
	FILE *fp;fp=fopen(nom,"wb");
	fwrite(paleta,256*3,1,fp);fclose(fp);}
